Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ boot/Makefile.common	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -102,5 +102,4 @@
 	$(USPACE_PATH)/srv/fs/tmpfs/tmpfs \
 	$(USPACE_PATH)/srv/fs/fat/fat \
-	$(USPACE_PATH)/srv/fs/exfat/exfat \
 	$(USPACE_PATH)/srv/fs/ext2fs/ext2fs \
 	$(USPACE_PATH)/srv/taskmon/taskmon \
@@ -149,6 +148,4 @@
 	$(USPACE_PATH)/app/dload/dload \
 	$(USPACE_PATH)/app/edit/edit \
-	$(USPACE_PATH)/app/filecrc/filecrc \
-	$(USPACE_PATH)/app/filegen/filegen \
 	$(USPACE_PATH)/app/ext2info/ext2info \
 	$(USPACE_PATH)/app/kill/kill \
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/Makefile	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -39,6 +39,4 @@
 	app/devctl \
 	app/edit \
-	app/filecrc \
-	app/filegen \
 	app/ext2info \
 	app/getterm \
@@ -81,5 +79,4 @@
 	srv/bd/part/guid_part \
 	srv/bd/part/mbr_part \
-	srv/fs/exfat \
 	srv/fs/fat \
 	srv/fs/tmpfs \
Index: uspace/app/mkfat/fat.h
===================================================================
--- uspace/app/mkfat/fat.h	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/app/mkfat/fat.h	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -38,14 +38,6 @@
 #define BS_BLOCK		0
 #define BS_SIZE			512
+
 #define DIRENT_SIZE		32
-
-#define FAT12_CLST_MAX    4085
-#define FAT16_CLST_MAX    65525
-
-#define FAT12	12
-#define FAT16	16
-#define FAT32	32
-
-#define FAT_SIZE(a) ((a==FAT12)? 1.5 : ( (a==FAT16)? 2 : 4  ) ) 
 
 typedef struct fat_bs {
Index: uspace/app/mkfat/mkfat.c
===================================================================
--- uspace/app/mkfat/mkfat.c	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/app/mkfat/mkfat.c	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -35,5 +35,5 @@
  * @brief	Tool for creating new FAT file systems.
  *
- * Currently we can create 12/16/32-bit FAT.
+ * Currently we can only create 16-bit FAT.
  */
 
@@ -55,37 +55,40 @@
 #define div_round_up(a, b) (((a) + (b) - 1) / (b))
 
-/** Default file-system parameters */
+/** Predefined file-system parameters */
 enum {
-	default_sector_size		= 512,
-	default_sectors_per_cluster	= 4,
-	default_fat_count		= 2,
-	default_reserved_clusters	= 2,
-	default_media_descriptor	= 0xF8 /**< fixed disk */
+	sector_size		= 512,
+	sectors_per_cluster	= 8,
+	fat_count		= 2,
+	reserved_clusters	= 2,
+	media_descriptor	= 0xF8 /**< fixed disk */
 };
 
 /** Configurable file-system parameters */
 typedef struct fat_cfg {
-	int fat_type; /* FAT12 = 12, FAT16 = 16, FAT32 = 32 */
-	size_t sector_size;
 	uint32_t total_sectors;
 	uint16_t root_ent_max;
-	uint32_t addt_res_sectors;
-	uint8_t sectors_per_cluster;
-
+	uint16_t addt_res_sectors;
+} fat_cfg_t;
+
+/** Derived file-system parameters */
+typedef struct fat_params {
+	struct fat_cfg cfg;
 	uint16_t reserved_sectors;
-	uint32_t rootdir_sectors;
+	uint16_t rootdir_sectors;
 	uint32_t fat_sectors;
-	uint32_t total_clusters;
-	uint8_t fat_count;
-} fat_cfg_t;
+	uint16_t total_clusters;
+} fat_params_t;
 
 static void syntax_print(void);
 
-static int fat_params_compute(struct fat_cfg *cfg);
-static int fat_blocks_write(struct fat_cfg const *cfg, service_id_t service_id);
-static void fat_bootsec_create(struct fat_cfg const *cfg, struct fat_bs *bs);
+static int fat_params_compute(struct fat_cfg const *cfg,
+    struct fat_params *par);
+static int fat_blocks_write(struct fat_params const *par,
+    service_id_t service_id);
+static void fat_bootsec_create(struct fat_params const *par, struct fat_bs *bs);
 
 int main(int argc, char **argv)
 {
+	struct fat_params par;
 	struct fat_cfg cfg;
 
@@ -93,14 +96,11 @@
 	char *dev_path;
 	service_id_t service_id;
+	size_t block_size;
 	char *endptr;
 	aoff64_t dev_nblocks;
 
-	cfg.sector_size = default_sector_size;
-	cfg.sectors_per_cluster = default_sectors_per_cluster;
-	cfg.fat_count = default_fat_count;
 	cfg.total_sectors = 0;
 	cfg.addt_res_sectors = 0;
 	cfg.root_ent_max = 128;
-	cfg.fat_type = FAT16;
 
 	if (argc < 2) {
@@ -111,4 +111,5 @@
 
 	--argc; ++argv;
+
 	if (str_cmp(*argv, "--size") == 0) {
 		--argc; ++argv;
@@ -129,22 +130,4 @@
 	}
 
-	if (str_cmp(*argv, "--type") == 0) {
-		--argc; ++argv;
-		if (*argv == NULL) {
-			printf(NAME ": Error, argument missing.\n");
-			syntax_print();
-			return 1;
-		}
-
-		cfg.fat_type = strtol(*argv, &endptr, 10);
-		if (*endptr != '\0') {
-			printf(NAME ": Error, invalid argument.\n");
-			syntax_print();
-			return 1;
-		}
-
-		--argc; ++argv;
-	}
-
 	if (argc != 1) {
 		printf(NAME ": Error, unexpected argument.\n");
@@ -154,5 +137,4 @@
 
 	dev_path = *argv;
-	printf("Device: %s\n", dev_path);
 
 	rc = loc_service_get_id(dev_path, &service_id, 0);
@@ -168,5 +150,5 @@
 	}
 
-	rc = block_get_bsize(service_id, &cfg.sector_size);
+	rc = block_get_bsize(service_id, &block_size);
 	if (rc != EOK) {
 		printf(NAME ": Error determining device block size.\n");
@@ -183,6 +165,6 @@
 	}
 
-	if (cfg.fat_type == FAT12 && cfg.sector_size != 512) {
-		printf(NAME ": Error. Device block size is not 512 bytes for FAT12 file system.\n");
+	if (block_size != 512) {
+		printf(NAME ": Error. Device block size is not 512 bytes.\n");
 		return 2;
 	}
@@ -193,7 +175,7 @@
 	}
 
-	printf(NAME ": Creating FAT%d filesystem on device %s.\n", cfg.fat_type, dev_path);
-
-	rc = fat_params_compute(&cfg);
+	printf(NAME ": Creating FAT filesystem on device %s.\n", dev_path);
+
+	rc = fat_params_compute(&cfg, &par);
 	if (rc != EOK) {
 		printf(NAME ": Invalid file-system parameters.\n");
@@ -201,5 +183,5 @@
 	}
 
-	rc = fat_blocks_write(&cfg, service_id);
+	rc = fat_blocks_write(&par, service_id);
 	if (rc != EOK) {
 		printf(NAME ": Error writing device.\n");
@@ -215,5 +197,5 @@
 static void syntax_print(void)
 {
-	printf("syntax: mkfat32 [--size <sectors>] [--type 12|16|32] <device_name>\n");
+	printf("syntax: mkfat [--size <num_blocks>] <device_name>\n");
 }
 
@@ -223,5 +205,5 @@
  * file system params.
  */
-static int fat_params_compute(struct fat_cfg *cfg)
+static int fat_params_compute(struct fat_cfg const *cfg, struct fat_params *par)
 {
 	uint32_t fat_bytes;
@@ -229,33 +211,22 @@
 
 	/*
-     * Make a conservative guess on the FAT size needed for the file
-     * system. The optimum could be potentially smaller since we
-     * do not subtract size of the FAT itself when computing the
-     * size of the data region.
-     */
-
-	if (cfg->fat_type == FAT12)
-		cfg->sectors_per_cluster = 1;
-
-	cfg->reserved_sectors = 1 + cfg->addt_res_sectors;
-	if (cfg->fat_type != FAT32) {
-		cfg->rootdir_sectors = div_round_up(cfg->root_ent_max * DIRENT_SIZE,
-			cfg->sector_size);
-	}
-	else
-		cfg->rootdir_sectors = 0;
-	non_data_sectors_lb = cfg->reserved_sectors + cfg->rootdir_sectors;
-
-	cfg->total_clusters = div_round_up(cfg->total_sectors - non_data_sectors_lb,
-	    cfg->sectors_per_cluster);
-
-	if ((cfg->fat_type == FAT12 && cfg->total_clusters > FAT12_CLST_MAX) ||
-		(cfg->fat_type == FAT16 && (cfg->total_clusters <= FAT12_CLST_MAX ||
-		cfg->total_clusters > FAT16_CLST_MAX)) ||
-	    (cfg->fat_type == FAT32 && cfg->total_clusters <= FAT16_CLST_MAX))
-		return ENOSPC;
-
-	fat_bytes = (cfg->total_clusters + 2) * FAT_SIZE(cfg->fat_type);
-	cfg->fat_sectors = div_round_up(fat_bytes, cfg->sector_size);
+         * Make a conservative guess on the FAT size needed for the file
+         * system. The optimum could be potentially smaller since we
+         * do not subtract size of the FAT itself when computing the
+         * size of the data region.
+         */
+
+	par->reserved_sectors = 1 + cfg->addt_res_sectors;
+	par->rootdir_sectors = div_round_up(cfg->root_ent_max * DIRENT_SIZE,
+	    sector_size);
+	non_data_sectors_lb = par->reserved_sectors + par->rootdir_sectors;
+
+	par->total_clusters = div_round_up(cfg->total_sectors - non_data_sectors_lb,
+	    sectors_per_cluster);
+
+	fat_bytes = (par->total_clusters + 2) * 2;
+	par->fat_sectors = div_round_up(fat_bytes, sector_size);
+
+	par->cfg = *cfg;
 
 	return EOK;
@@ -263,5 +234,5 @@
 
 /** Create file system with the given parameters. */
-static int fat_blocks_write(struct fat_cfg const *cfg, service_id_t service_id)
+static int fat_blocks_write(struct fat_params const *par, service_id_t service_id)
 {
 	aoff64_t addr;
@@ -272,5 +243,5 @@
 	struct fat_bs bs;
 
-	fat_bootsec_create(cfg, &bs);
+	fat_bootsec_create(par, &bs);
 
 	rc = block_write_direct(service_id, BS_BLOCK, 1, &bs);
@@ -280,11 +251,10 @@
 	addr = BS_BLOCK + 1;
 
-	buffer = calloc(cfg->sector_size, 1);
+	buffer = calloc(sector_size, 1);
 	if (buffer == NULL)
 		return ENOMEM;
-	memset(buffer, 0, cfg->sector_size);
 
 	/* Reserved sectors */
-	for (i = 0; i < cfg->reserved_sectors - 1; ++i) {
+	for (i = 0; i < par->reserved_sectors - 1; ++i) {
 		rc = block_write_direct(service_id, addr, 1, buffer);
 		if (rc != EOK)
@@ -295,26 +265,14 @@
 
 	/* File allocation tables */
-	for (i = 0; i < cfg->fat_count; ++i) {
+	for (i = 0; i < fat_count; ++i) {
 		printf("Writing allocation table %d.\n", i + 1);
 
-		for (j = 0; j < cfg->fat_sectors; ++j) {
-			memset(buffer, 0, cfg->sector_size);
+		for (j = 0; j < par->fat_sectors; ++j) {
+			memset(buffer, 0, sector_size);
 			if (j == 0) {
-				buffer[0] = default_media_descriptor;
+				buffer[0] = media_descriptor;
 				buffer[1] = 0xFF;
 				buffer[2] = 0xFF;
-				if (cfg->fat_type == FAT16) {
-					buffer[3] = 0xFF;
-				} else if (cfg->fat_type == FAT32) {
-					buffer[3] = 0x0F;
-					buffer[4] = 0xFF;
-					buffer[5] = 0xFF;
-					buffer[6] = 0xFF;
-					buffer[7] = 0x0F;
-					buffer[8] = 0xF8;
-					buffer[9] = 0xFF;
-					buffer[10] = 0xFF;
-					buffer[11] = 0x0F;
-				}
+				buffer[3] = 0xFF;
 			}
 
@@ -327,24 +285,15 @@
 	}
 
+	printf("Writing root directory.\n");
+
+	memset(buffer, 0, sector_size);
+
 	/* Root directory */
-	printf("Writing root directory.\n");
-	memset(buffer, 0, cfg->sector_size);
-	if (cfg->fat_type != FAT32) {
-		size_t idx;
-		for (idx = 0; idx < cfg->rootdir_sectors; ++idx) {
-			rc = block_write_direct(service_id, addr, 1, buffer);
-			if (rc != EOK)
-				return EIO;
-
-			++addr;
-		}
-	} else {
-		for (i=0; i<cfg->sectors_per_cluster; i++) {
-			rc = block_write_direct(service_id, addr, 1, buffer);
-			if (rc != EOK)
-				return EIO;
-
-			++addr;
-		}	
+	for (i = 0; i < par->rootdir_sectors; ++i) {
+		rc = block_write_direct(service_id, addr, 1, buffer);
+		if (rc != EOK)
+			return EIO;
+
+		++addr;
 	}
 
@@ -355,5 +304,5 @@
 
 /** Construct boot sector with the given parameters. */
-static void fat_bootsec_create(struct fat_cfg const *cfg, struct fat_bs *bs)
+static void fat_bootsec_create(struct fat_params const *par, struct fat_bs *bs)
 {
 	memset(bs, 0, sizeof(*bs));
@@ -366,44 +315,34 @@
 
 	/* BIOS Parameter Block */
-	bs->bps = host2uint16_t_le(cfg->sector_size);
-	bs->spc = cfg->sectors_per_cluster;
-	bs->rscnt = host2uint16_t_le(cfg->reserved_sectors);
-	bs->fatcnt = cfg->fat_count;
-	bs->root_ent_max = host2uint16_t_le(cfg->root_ent_max);
-
-	if (cfg->total_sectors < 0x10000) {
-		bs->totsec16 = host2uint16_t_le(cfg->total_sectors);
-		bs->totsec32 = 0;
-	} else {
-		bs->totsec16 = 0;
-		bs->totsec32 = host2uint32_t_le(cfg->total_sectors);
-	}
-
-	bs->mdesc = default_media_descriptor;
+	bs->bps = host2uint16_t_le(sector_size);
+	bs->spc = sectors_per_cluster;
+	bs->rscnt = host2uint16_t_le(par->reserved_sectors);
+	bs->fatcnt = fat_count;
+	bs->root_ent_max = host2uint16_t_le(par->cfg.root_ent_max);
+
+	if (par->cfg.total_sectors < 0x10000)
+		bs->totsec16 = host2uint16_t_le(par->cfg.total_sectors);
+	else
+		bs->totsec16 = host2uint16_t_le(0);
+
+	bs->mdesc = media_descriptor;
+	bs->sec_per_fat = host2uint16_t_le(par->fat_sectors);
 	bs->sec_per_track = host2uint16_t_le(63);
-	bs->signature = host2uint16_t_be(0x55AA);
 	bs->headcnt = host2uint16_t_le(6);
 	bs->hidden_sec = host2uint32_t_le(0);
 
-	if (cfg->fat_type == FAT32) {
-		bs->sec_per_fat = 0;
-		bs->fat32.sectors_per_fat = host2uint32_t_le(cfg->fat_sectors);
-
-		bs->fat32.pdn = 0x80;
-		bs->fat32.ebs = 0x29;
-		bs->fat32.id = host2uint32_t_be(0x12345678);
-		bs->fat32.root_cluster = 2;
-
-		memcpy(bs->fat32.label, "HELENOS_NEW", 11);
-		memcpy(bs->fat32.type, "FAT32   ", 8);
-	} else {
-		bs->sec_per_fat = host2uint16_t_le(cfg->fat_sectors);
-		bs->pdn = 0x80;
-		bs->ebs = 0x29;
-		bs->id = host2uint32_t_be(0x12345678);
-
-		memcpy(bs->label, "HELENOS_NEW", 11);
-		memcpy(bs->type, "FAT   ", 8);
-	}
+	if (par->cfg.total_sectors >= 0x10000)
+		bs->totsec32 = host2uint32_t_le(par->cfg.total_sectors);
+	else
+		bs->totsec32 = host2uint32_t_le(0);
+
+	/* Extended BPB */
+	bs->pdn = 0x80;
+	bs->ebs = 0x29;
+	bs->id = host2uint32_t_be(0x12345678);
+
+	memcpy(bs->label, "HELENOS_NEW", 11);
+	memcpy(bs->type, "FAT16   ", 8);
+	bs->signature = host2uint16_t_be(0x55AA);
 }
 
Index: uspace/lib/c/generic/str.c
===================================================================
--- uspace/lib/c/generic/str.c	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/lib/c/generic/str.c	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -3,5 +3,4 @@
  * Copyright (c) 2008 Jiri Svoboda
  * Copyright (c) 2011 Martin Sucha
- * Copyright (c) 2011 Oleg Romanenko
  * All rights reserved.
  *
@@ -368,16 +367,4 @@
 }
 
-/** Check whether wide string is plain ASCII.
- *
- * @return True if wide string is plain ASCII.
- *
- */
-bool wstr_is_ascii(const wchar_t *wstr)
-{
-	while (*wstr && ascii_check(*wstr))
-		wstr++;
-	return *wstr == 0;
-}
-
 /** Check whether character is valid
  *
@@ -632,10 +619,7 @@
  * @param size	Size of the destination buffer.
  * @param src	Source wide string.
- *
- * @return EOK, if success, negative otherwise.
- */
-int wstr_to_str(char *dest, size_t size, const wchar_t *src)
-{
-	int rc;
+ */
+void wstr_to_str(char *dest, size_t size, const wchar_t *src)
+{
 	wchar_t ch;
 	size_t src_idx;
@@ -649,90 +633,10 @@
 
 	while ((ch = src[src_idx++]) != 0) {
-		rc = chr_encode(ch, dest, &dest_off, size - 1);
-		if (rc != EOK)
+		if (chr_encode(ch, dest, &dest_off, size - 1) != EOK)
 			break;
 	}
 
 	dest[dest_off] = '\0';
-	return rc;
-}
-
-/** Convert UTF16 string to string.
- *
- * Convert utf16 string @a src to string. The output is written to the buffer
- * specified by @a dest and @a size. @a size must be non-zero and the string
- * written will always be well-formed. Surrogate pairs also supported.
- *
- * @param dest	Destination buffer.
- * @param size	Size of the destination buffer.
- * @param src	Source utf16 string.
- *
- * @return EOK, if success, negative otherwise.
- */
-int utf16_to_str(char *dest, size_t size, const uint16_t *src)
-{
-	size_t idx=0, dest_off=0;
-	wchar_t ch;
-	int rc = EOK;
-
-	/* There must be space for a null terminator in the buffer. */
-	assert(size > 0);
-
-	while (src[idx]) {
-		if ((src[idx] & 0xfc00) == 0xd800) {
-			if (src[idx+1] && (src[idx+1] & 0xfc00) == 0xdc00) {
-				ch = 0x10000;
-				ch += (src[idx] & 0x03FF) << 10;
-				ch += (src[idx+1] & 0x03FF);
-				idx += 2;
-			}
-			else
-				break;
-		} else {
-			ch = src[idx];
-			idx++;
-		}
-		rc = chr_encode(ch, dest, &dest_off, size-1);
-		if (rc != EOK)
-			break;
-	}
-	dest[dest_off] = '\0';
-	return rc;
-}
-
-int str_to_utf16(uint16_t *dest, size_t size, const char *src)
-{
-	int rc=EOK;
-	size_t offset=0;
-	size_t idx=0;
-	wchar_t c;
-
-	assert(size > 0);
-	
-	while ((c = str_decode(src, &offset, STR_NO_LIMIT)) != 0) {
-		if (c > 0x10000) {
-			if (idx+2 >= size-1) {
-				rc=EOVERFLOW;
-				break;
-			}
-			c = (c - 0x10000);
-			dest[idx] = 0xD800 | (c >> 10);
-			dest[idx+1] = 0xDC00 | (c & 0x3FF);
-			idx++;
-		} else {
-			 dest[idx] = c;
-		}
-
-		idx++;
-		if (idx >= size-1) {
-			rc=EOVERFLOW;
-			break;
-		}
-	}
-
-	dest[idx] = '\0';
-	return rc;
-}
-
+}
 
 /** Convert wide string to new string.
@@ -794,10 +698,7 @@
  * @param dlen	Length of destination buffer (number of wchars).
  * @param src	Source string.
- *
- * @return EOK, if success, negative otherwise.
- */
-int str_to_wstr(wchar_t *dest, size_t dlen, const char *src)
-{
-	int rc=EOK;
+ */
+void str_to_wstr(wchar_t *dest, size_t dlen, const char *src)
+{
 	size_t offset;
 	size_t di;
@@ -810,8 +711,6 @@
 
 	do {
-		if (di >= dlen - 1) {
-			rc = EOVERFLOW;
+		if (di >= dlen - 1)
 			break;
-		}
 
 		c = str_decode(src, &offset, STR_NO_LIMIT);
@@ -820,5 +719,4 @@
 
 	dest[dlen - 1] = '\0';
-	return rc;
 }
 
@@ -885,39 +783,4 @@
 	
 	return (char *) res;
-}
-
-/** Find first occurence of character in wide string.
- *
- * @param wstr String to search.
- * @param ch  Character to look for.
- *
- * @return Pointer to character in @a wstr or NULL if not found.
- */
-wchar_t *wstr_chr(const wchar_t *wstr, wchar_t ch)
-{
-	while (*wstr && *wstr != ch)
-		wstr++;
-	if (*wstr)
-		return (wchar_t *) wstr;
-	else
-		return NULL;
-}
-
-/** Find last occurence of character in wide string.
- *
- * @param wstr String to search.
- * @param ch  Character to look for.
- *
- * @return Pointer to character in @a wstr or NULL if not found.
- */
-wchar_t *wstr_rchr(const wchar_t *wstr, wchar_t ch)
-{
-	const wchar_t *res = NULL;
-	while (*wstr) {
-		if (*wstr == ch)
-			res = wstr;
-		wstr++;
-	}
-	return (wchar_t *) res;
 }
 
@@ -1174,34 +1037,4 @@
 }
 
-void str_reverse(char* begin, char* end) 
-{
-    char aux;
-    while(end>begin)
-        aux=*end, *end--=*begin, *begin++=aux;
-}
-
-int size_t_str(size_t value, int base, char* str, size_t size) 
-{
-    static char num[] = "0123456789abcdefghijklmnopqrstuvwxyz";
-    char* wstr=str;
-	
-	if (size == 0) 
-		return EINVAL;
-    if (base<2 || base>35) {
-        *str='\0';
-        return EINVAL;
-    }
-
-    do {
-        *wstr++ = num[value % base];
-		if (--size == 0)
-			return EOVERFLOW;
-    } while(value /= base);
-    *wstr='\0';
-
-    // Reverse string
-    str_reverse(str,wstr-1);
-	return EOK;
-}
 
 /** Convert initial part of string to unsigned long according to given base.
Index: uspace/lib/c/include/str.h
===================================================================
--- uspace/lib/c/include/str.h	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/lib/c/include/str.h	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -1,5 +1,4 @@
 /*
  * Copyright (c) 2005 Martin Decky
- * Copyright (c) 2011 Oleg Romanenko
  * All rights reserved.
  *
@@ -72,5 +71,4 @@
 extern bool ascii_check(wchar_t ch);
 extern bool chr_check(wchar_t ch);
-extern bool wstr_is_ascii(const wchar_t *wstr);
 
 extern int str_cmp(const char *s1, const char *s2);
@@ -81,16 +79,12 @@
 extern void str_append(char *dest, size_t size, const char *src);
 
-extern int wstr_to_str(char *dest, size_t size, const wchar_t *src);
 extern int spascii_to_str(char *dest, size_t size, const uint8_t *src, size_t n);
+extern void wstr_to_str(char *dest, size_t size, const wchar_t *src);
 extern char *wstr_to_astr(const wchar_t *src);
+extern void str_to_wstr(wchar_t *dest, size_t dlen, const char *src);
 extern wchar_t *str_to_awstr(const char *src);
-extern int str_to_wstr(wchar_t *dest, size_t dlen, const char *src);
-extern int utf16_to_str(char *dest, size_t size, const uint16_t *src);
-extern int str_to_utf16(uint16_t *dest, size_t size, const char *src);
 
 extern char *str_chr(const char *str, wchar_t ch);
 extern char *str_rchr(const char *str, wchar_t ch);
-extern wchar_t *wstr_chr(const wchar_t *wstr, wchar_t ch);
-extern wchar_t *wstr_rchr(const wchar_t *wstr, wchar_t ch);
 
 extern bool wstr_linsert(wchar_t *str, wchar_t ch, size_t pos, size_t max_pos);
@@ -99,7 +93,4 @@
 extern char *str_dup(const char *);
 extern char *str_ndup(const char *, size_t max_size);
-
-extern void str_reverse(char* begin, char* end);
-extern int size_t_str(size_t value, int base, char* str, size_t size);
 
 extern int str_uint64(const char *, char **, unsigned int, bool, uint64_t *);
Index: uspace/srv/fs/fat/Makefile
===================================================================
--- uspace/srv/fs/fat/Makefile	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/srv/fs/fat/Makefile	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -39,5 +39,4 @@
 	fat_idx.c \
 	fat_dentry.c \
-	fat_directory.c \
 	fat_fat.c
 
Index: uspace/srv/fs/fat/fat.c
===================================================================
--- uspace/srv/fs/fat/fat.c	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/srv/fs/fat/fat.c	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -2,5 +2,4 @@
  * Copyright (c) 2006 Martin Decky
  * Copyright (c) 2008 Jakub Jermar
- * Copyright (c) 2011 Oleg Romanenko
  * All rights reserved.
  *
Index: uspace/srv/fs/fat/fat.h
===================================================================
--- uspace/srv/fs/fat/fat.h	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/srv/fs/fat/fat.h	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -1,5 +1,4 @@
 /*
  * Copyright (c) 2008 Jakub Jermar
- * Copyright (c) 2011 Oleg Romanenko
  * All rights reserved.
  *
@@ -56,7 +55,5 @@
 #define RSCNT(bs)	uint16_t_le2host((bs)->rscnt)
 #define FATCNT(bs)	(bs)->fatcnt
-#define SF(bs)		(uint16_t_le2host((bs)->sec_per_fat) !=0 ? \
-    uint16_t_le2host((bs)->sec_per_fat) : \
-    uint32_t_le2host(bs->fat32.sectors_per_fat))
+#define SF(bs)		uint16_t_le2host((bs)->sec_per_fat)
 #define RDE(bs)		uint16_t_le2host((bs)->root_ent_max)
 #define TS(bs)		(uint16_t_le2host((bs)->totsec16) != 0 ? \
Index: uspace/srv/fs/fat/fat_dentry.c
===================================================================
--- uspace/srv/fs/fat/fat_dentry.c	(revision 375ab5e571cc53eeb2aa803a8e86052b51d7ad00)
+++ uspace/srv/fs/fat/fat_dentry.c	(revision 7fadb6526b88d8a8d0bbeb5d5997969a53e7e66d)
@@ -1,5 +1,4 @@
 /*
  * Copyright (c) 2008 Jakub Jermar
- * Copyright (c) 2011 Oleg Romanenko
  * All rights reserved.
  *
@@ -40,7 +39,12 @@
 #include <ctype.h>
 #include <str.h>
-#include <errno.h>
-#include <byteorder.h>
-#include <assert.h>
+
+static bool is_d_char(const char ch)
+{
+	if (isalnum(ch) || ch == '_')
+		return true;
+	else
+		return false;
+}
 
 /** Compare path component with the name read from the dentry.
@@ -76,297 +80,10 @@
 }
 
-void fat_dentry_name_get(const fat_dentry_t *d, char *buf)
-{
-	unsigned int i;
-	
-	for (i = 0; i < FAT_NAME_LEN; i++) {
-		if (d->name[i] == FAT_PAD)
-			break;
-		
-		if (d->name[i] == FAT_DENTRY_E5_ESC)
-			*buf++ = 0xe5;
-		else {
-			if (d->lcase & FAT_LCASE_LOWER_NAME)
-				*buf++ = tolower(d->name[i]);
-			else
-				*buf++ = d->name[i];
-		}
-	}
-	
-	if (d->ext[0] != FAT_PAD)
-		*buf++ = '.';
-	
-	for (i = 0; i < FAT_EXT_LEN; i++) {
-		if (d->ext[i] == FAT_PAD) {
-			*buf = '\0';
-			return;
-		}
-		
-		if (d->ext[i] == FAT_DENTRY_E5_ESC)
-			*buf++ = 0xe5;
-		else {
-			if (d->lcase & FAT_LCASE_LOWER_EXT)
-				*buf++ = tolower(d->ext[i]);
-			else
-				*buf++ = d->ext[i];
-		}
-	}
-	
-	*buf = '\0';
-}
-
-void fat_dentry_name_set(fat_dentry_t *d, const char *name)
-{
-	unsigned int i;
-	const char fake_ext[] = "   ";
-	bool lower_name = true;
-	bool lower_ext = true;
-	
-	for (i = 0; i < FAT_NAME_LEN; i++) {
-		switch ((uint8_t) *name) {
-		case 0xe5:
-			d->name[i] = FAT_DENTRY_E5_ESC;
-			name++;
-			break;
-		case '\0':
-		case '.':
-			d->name[i] = FAT_PAD;
-			break;
-		default:
-			if (isalpha(*name)) {
-				if (!islower(*name))
-					lower_name = false;
-			}
-			
-			d->name[i] = toupper(*name++);
-			break;
-		}
-	}
-	
-	if (*name++ != '.')
-		name = fake_ext;
-	
-	for (i = 0; i < FAT_EXT_LEN; i++) {
-		switch ((uint8_t) *name) {
-		case 0xe5:
-			d->ext[i] = FAT_DENTRY_E5_ESC;
-			name++;
-			break;
-		case '\0':
-			d->ext[i] = FAT_PAD;
-			break;
-		default:
-			if (isalpha(*name)) {
-				if (!islower(*name))
-					lower_ext = false;
-			}
-			
-			d->ext[i] = toupper(*name++);
-			break;
-		}
-	}
-	
-	if (lower_name)
-		d->lcase |= FAT_LCASE_LOWER_NAME;
-	else
-		d->lcase &= ~FAT_LCASE_LOWER_NAME;
-	
-	if (lower_ext)
-		d->lcase |= FAT_LCASE_LOWER_EXT;
-	else
-		d->lcase &= ~FAT_LCASE_LOWER_EXT;
-}
-
-fat_dentry_clsf_t fat_classify_dentry(const fat_dentry_t *d)
-{
-	if (d->attr == FAT_ATTR_LFN) {
-		/* long name entry */
-		if (FAT_LFN_ORDER(d) & FAT_LFN_ERASED)
-			return FAT_DENTRY_FREE;
-		else
-			return FAT_DENTRY_LFN;
-	}
-	if (d->attr & FAT_ATTR_VOLLABEL) {
-		/* volume label entry */
-		return FAT_DENTRY_SKIP;
-	}
-	if (d->name[0] == FAT_DENTRY_ERASED) {
-		/* not-currently-used entry */
-		return FAT_DENTRY_FREE;
-	}
-	if (d->name[0] == FAT_DENTRY_UNUSED) {
-		/* never used entry */
-		return FAT_DENTRY_LAST;
-	}
-	if (d->name[0] == FAT_DENTRY_DOT) {
-		/*
-		 * Most likely '.' or '..'.
-		 * It cannot occur in a regular file name.
-		 */
-		return FAT_DENTRY_SKIP;
-	}
-	return FAT_DENTRY_VALID;
-}
-
-/** Compute checksum of Node name.
- *
- * Returns an unsigned byte checksum computed on an unsigned byte
- * array. The array must be 11 bytes long and is assumed to contain
- * a name stored in the format of a MS-DOS directory entry.
- *
- * @param name		Node name read from the dentry.
- *
- * @return		An 8-bit unsigned checksum of the name.
- */
-uint8_t fat_dentry_chksum(uint8_t *name)
-{
-	uint8_t i, sum=0;
-	for (i=0; i<(FAT_NAME_LEN+FAT_EXT_LEN); i++) {
-		sum = ((sum & 1) ? 0x80 : 0) + (sum >> 1) + name[i];
-	}
-	return sum;
-}
-
-/** Get number of bytes in a string with size limit.
- *
- * @param str  NULL-terminated (or not) string.
- * @param size Maximum number of bytes to consider.
- *
- * @return Number of bytes in string (without 0 and ff).
- *
- */
-size_t fat_lfn_str_nlength(const uint16_t *str, size_t size)
-{
-	size_t offset = 0;
-
-	while (offset < size) {
-		if (str[offset] == 0 || str[offset] == FAT_LFN_PAD) 
-			break;
-		offset++;
-	}
-	return offset;
-}
-
-/** Get number of bytes in a FAT long entry occuped by characters.
- *
- * @param d FAT long entry.
- *
- * @return Number of bytes.
- *
- */
-size_t fat_lfn_size(const fat_dentry_t *d)
-{
-	size_t size = 0;
-	
-	size += fat_lfn_str_nlength(FAT_LFN_PART1(d), FAT_LFN_PART1_SIZE);
-	size += fat_lfn_str_nlength(FAT_LFN_PART2(d), FAT_LFN_PART2_SIZE);
-	size += fat_lfn_str_nlength(FAT_LFN_PART3(d), FAT_LFN_PART3_SIZE);	
-	
-	return size;
-}
-
-size_t fat_lfn_get_entry(const fat_dentry_t *d, uint16_t *dst, size_t *offset)
-{
-	int i;
-	for (i=FAT_LFN_PART3_SIZE-1; i>=0 && *offset>0; i--) {
-		if (d->lfn.part3[i] == 0 || d->lfn.part3[i] == FAT_LFN_PAD)
-			continue;
-		(*offset)--;
-		dst[(*offset)] = uint16_t_le2host(d->lfn.part3[i]);
-	}
-	for (i=FAT_LFN_PART2_SIZE-1; i>=0 && *offset>0; i--) {
-		if (d->lfn.part2[i] == 0 || d->lfn.part2[i] == FAT_LFN_PAD)
-			continue;
-		(*offset)--;
-		dst[(*offset)] = uint16_t_le2host(d->lfn.part2[i]);
-	}
-	for (i=FAT_LFN_PART1_SIZE-1; i>=0 && *offset>0; i--) {
-		if (d->lfn.part1[i] == 0 || d->lfn.part1[i] == FAT_LFN_PAD)
-			continue;
-		(*offset)--;
-		dst[(*offset)] = uint16_t_le2host(d->lfn.part1[i]);
-	}
-	return *offset;
-}
-
-size_t fat_lfn_set_entry(const uint16_t *src, size_t *offset, size_t size, fat_dentry_t *d)
-{
-	size_t idx;
-	for (idx=0; idx < FAT_LFN_PART1_SIZE; idx++) {
-		if (*offset < size) {
-			d->lfn.part1[idx] = host2uint16_t_le(src[*offset]);
-			(*offset)++;
-		}
-		else
-			d->lfn.part1[idx] = FAT_LFN_PAD;
-	}
-	for (idx=0; idx < FAT_LFN_PART2_SIZE; idx++) {
-		if (*offset < size) {
-			d->lfn.part2[idx] = host2uint16_t_le(src[*offset]);
-			(*offset)++;
-		}
-		else
-			d->lfn.part2[idx] = FAT_LFN_PAD;
-	}
-	for (idx=0; idx < FAT_LFN_PART3_SIZE; idx++) {
-		if (*offset < size) {
-			d->lfn.part3[idx] = host2uint16_t_le(src[*offset]);
-			(*offset)++;
-		}
-		else
-			d->lfn.part3[idx] = FAT_LFN_PAD;
-	}
-
-	if (src[*offset] == 0)
-		offset++;
-	FAT_LFN_ATTR(d) = FAT_ATTR_LFN;
-	d->lfn.type = 0;
-	d->lfn.firstc_lo = 0;
-	
-	return *offset;
-}
-
-void str_to_ascii(char *dst, const char *src, size_t count, uint8_t pad)
-{
-	wchar_t ch;
-	size_t off = 0;
-	size_t i = 0;
-	
-	while (i < count) {
-		if ((ch = str_decode(src, &off, STR_NO_LIMIT)) != 0) {
-			if (ascii_check(ch) & IS_D_CHAR(ch))
-				*dst = toupper(ch);
-			else
-				*dst = pad;
-		}
-		else
-			break;
-
-		dst++;
-		i++;
-	}
-	*dst = '\0';
-}
-
-bool fat_valid_name(const char *name)
-{
-	wchar_t ch;
-	size_t offset=0;
-	bool result = true;
-	
-	while ((ch = str_decode(name, &offset, STR_NO_LIMIT)) != 0) {
-		if (wstr_chr(FAT_STOP_CHARS, ch) != NULL) {
-			result = false;
-			break;
-		}
-	}
-	return result;
-}
-
-bool fat_valid_short_name(const char *name)
+bool fat_dentry_name_verify(const char *name)
 {
 	unsigned int i;
 	unsigned int dot = 0;
 	bool dot_found = false;
+	
 
 	for (i = 0; name[i]; i++) {
@@ -379,5 +96,5 @@
 			}
 		} else {
-			if (!IS_D_CHAR(name[i]))
+			if (!is_d_char(name[i]))
 				return false;
 		}
@@ -397,12 +114,128 @@
 }
 
-size_t utf16_length(const uint16_t *wstr)
-{
-	size_t len = 0;
-	
-	while (*wstr++ != 0)
-		len++;
-	
-	return len;
+void fat_dentry_name_get(const fat_dentry_t *d, char *buf)
+{
+	unsigned int i;
+	
+	for (i = 0; i < FAT_NAME_LEN; i++) {
+		if (d->name[i] == FAT_PAD)
+			break;
+		
+		if (d->name[i] == FAT_DENTRY_E5_ESC)
+			*buf++ = 0xe5;
+		else {
+			if (d->lcase & FAT_LCASE_LOWER_NAME)
+				*buf++ = tolower(d->name[i]);
+			else
+				*buf++ = d->name[i];
+		}
+	}
+	
+	if (d->ext[0] != FAT_PAD)
+		*buf++ = '.';
+	
+	for (i = 0; i < FAT_EXT_LEN; i++) {
+		if (d->ext[i] == FAT_PAD) {
+			*buf = '\0';
+			return;
+		}
+		
+		if (d->ext[i] == FAT_DENTRY_E5_ESC)
+			*buf++ = 0xe5;
+		else {
+			if (d->lcase & FAT_LCASE_LOWER_EXT)
+				*buf++ = tolower(d->ext[i]);
+			else
+				*buf++ = d->ext[i];
+		}
+	}
+	
+	*buf = '\0';
+}
+
+void fat_dentry_name_set(fat_dentry_t *d, const char *name)
+{
+	unsigned int i;
+	const char fake_ext[] = "   ";
+	bool lower_name = true;
+	bool lower_ext = true;
+	
+	for (i = 0; i < FAT_NAME_LEN; i++) {
+		switch ((uint8_t) *name) {
+		case 0xe5:
+			d->name[i] = FAT_DENTRY_E5_ESC;
+			name++;
+			break;
+		case '\0':
+		case '.':
+			d->name[i] = FAT_PAD;
+			break;
+		default:
+			if (isalpha(*name)) {
+				if (!islower(*name))
+					lower_name = false;
+			}
+			
+			d->name[i] = toupper(*name++);
+			break;
+		}
+	}
+	
+	if (*name++ != '.')
+		name = fake_ext;
+	
+	for (i = 0; i < FAT_EXT_LEN; i++) {
+		switch ((uint8_t) *name) {
+		case 0xe5:
+			d->ext[i] = FAT_DENTRY_E5_ESC;
+			name++;
+			break;
+		case '\0':
+			d->ext[i] = FAT_PAD;
+			break;
+		default:
+			if (isalpha(*name)) {
+				if (!islower(*name))
+					lower_ext = false;
+			}
+			
+			d->ext[i] = toupper(*name++);
+			break;
+		}
+	}
+	
+	if (lower_name)
+		d->lcase |= FAT_LCASE_LOWER_NAME;
+	else
+		d->lcase &= ~FAT_LCASE_LOWER_NAME;
+	
+	if (lower_ext)
+		d->lcase |= FAT_LCASE_LOWER_EXT;
+	else
+		d->lcase &= ~FAT_LCASE_LOWER_EXT;
+}
+
+fat_dentry_clsf_t fat_classify_dentry(const fat_dentry_t *d)
+{
+	if (d->attr & FAT_ATTR_VOLLABEL) {
+		/* volume label entry */
+		return FAT_DENTRY_SKIP;
+	}
+	if (d->name[0] == FAT_DENTRY_ERASED) {
+		/* not-currently-used entry */
+		return FAT_DENTRY_FREE;
+	}
+	if (d->name[0] == FAT_DENTRY_UNUSED) {
+		/* never used entry */
+		return FAT_DENTRY_LAST;
+	}
+	if (d->name[0] == FAT_DENTRY_DOT) {
+		/*
+		 * Most likely '.' or '..'.
+		 * It cannot occur in a regular file name.
+		 */
+		return FAT_DENTRY_SKIP;
+	}
+	return FAT_DENTRY_VALID;
 }
 
